Index: bootscripts/ChangeLog
===================================================================
--- bootscripts/ChangeLog	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/ChangeLog	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -1,2 +1,17 @@
+2100-09-18
+   * Review and update of changes made in previous change.
+   ** Rename /etc/sysconfig/init_params to /etc/sysconfig/rc.site.
+   ** Move network services to /lib/services.
+   ** Move init-functions to /lib/lsb.
+   *** /lib/lsb is a symlink to /lib/services.
+   * Create convenience symlink /etc/init.d->/etc/rc.d/init.d.
+   * Add help and man pages to upup/ifdown.
+   * Append /run/var/bootlog to /var/log/boot.log at the end of 
+     the boot sequence.
+   * Add capabiltiy to step through the boot scripts at boot time
+   * Optionally allow environment variables in sysconfig directory's 
+     console, network, and clock files to be placed in rc.site.
+   * Add an optional FASTBOOT parameter to set /fastboot when rebooting.
+
 2011-07-14  Bruce Dubbs <bdubbs@linuxfromscratch.org>
    * Major rewrite of all LFS scripts
Index: bootscripts/Makefile
===================================================================
--- bootscripts/Makefile	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/Makefile	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -1,32 +1,36 @@
 ETCDIR=/etc
 EXTDIR=${DESTDIR}${ETCDIR}
-LIBDIR=${DESTDIR}/lib/boot
+LIBDIR=${DESTDIR}/lib/services
+MAN8=/usr/share/man/man8
 MODE=754
 DIRMODE=755
 CONFMODE=644
 
-all: install
+all: links
+
+install: all
 
 create-dirs:
-	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/rc0.d
-	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/rc1.d
-	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/rc2.d
-	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/rc3.d
-	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/rc4.d
-	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/rc5.d
-	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/rc6.d
-	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/rcsysinit.d
-	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/init.d
-	install -d -m ${DIRMODE} ${EXTDIR}/sysconfig
-	install -d -m ${DIRMODE} ${LIBDIR}
+	install -d -m ${DIRMODE}  ${EXTDIR}/rc.d/rc0.d
+	install -d -m ${DIRMODE}  ${EXTDIR}/rc.d/rc1.d
+	install -d -m ${DIRMODE}  ${EXTDIR}/rc.d/rc2.d
+	install -d -m ${DIRMODE}  ${EXTDIR}/rc.d/rc3.d
+	install -d -m ${DIRMODE}  ${EXTDIR}/rc.d/rc4.d
+	install -d -m ${DIRMODE}  ${EXTDIR}/rc.d/rc5.d
+	install -d -m ${DIRMODE}  ${EXTDIR}/rc.d/rc6.d
+	install -d -m ${DIRMODE}  ${EXTDIR}/rc.d/rcS.d
+	install -d -m ${DIRMODE}  ${EXTDIR}/rc.d/init.d
+	install -d -m ${DIRMODE}  ${EXTDIR}/sysconfig
+	install -d -m ${DIRMODE}  ${LIBDIR}
+	ln -svf       services    ${DESTDIR}/lib/lsb
+	ln -sf        rc.d/init.d ${EXTDIR}/init.d
 
-install: create-dirs 
+files: create-dirs 
 	install -m ${MODE} lfs/init.d/checkfs       ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/cleanfs       ${EXTDIR}/rc.d/init.d/
-	install -m ${CONFMODE} lfs/init.d/functions ${EXTDIR}/rc.d/init.d/
-	install -m ${CONFMODE} lfs/init.d/functions ${LIBDIR}
 	install -m ${MODE} lfs/init.d/halt          ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/console       ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/consolelog    ${EXTDIR}/rc.d/init.d/
+	install -m ${CONFMODE} lfs/init.d/functions ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/localnet      ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/modules       ${EXTDIR}/rc.d/init.d/
@@ -38,46 +42,17 @@
 	install -m ${MODE} lfs/init.d/sendsignals   ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/setclock      ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/sysklogd      ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/swap          ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/sysctl        ${EXTDIR}/rc.d/init.d/
+	install -m ${MODE} lfs/init.d/sysklogd      ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/template      ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/udev          ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/udev_retry    ${EXTDIR}/rc.d/init.d/
-	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc0.d/K80network
-	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc0.d/K90sysklogd
-	ln -sf ../init.d/sendsignals ${EXTDIR}/rc.d/rc0.d/S60sendsignals
-	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rc0.d/S70mountfs
-	ln -sf ../init.d/swap        ${EXTDIR}/rc.d/rc0.d/S80swap
-	ln -sf ../init.d/localnet    ${EXTDIR}/rc.d/rc0.d/S90localnet
-	ln -sf ../init.d/halt        ${EXTDIR}/rc.d/rc0.d/S99halt
-	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc1.d/K80network
-	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc1.d/K90sysklogd
-	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc2.d/K80network
-	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc2.d/K90sysklogd
-	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc3.d/S10sysklogd
-	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc3.d/S20network
-	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc4.d/S10sysklogd
-	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc4.d/S20network
-	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc5.d/S10sysklogd
-	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc5.d/S20network
-	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc6.d/K80network
-	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc6.d/K90sysklogd
-	ln -sf ../init.d/sendsignals ${EXTDIR}/rc.d/rc6.d/S60sendsignals
-	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rc6.d/S70mountfs
-	ln -sf ../init.d/swap        ${EXTDIR}/rc.d/rc6.d/S80swap
-	ln -sf ../init.d/localnet    ${EXTDIR}/rc.d/rc6.d/S90localnet
-	ln -sf ../init.d/reboot      ${EXTDIR}/rc.d/rc6.d/S99reboot
-	ln -sf ../init.d/mountvirtfs ${EXTDIR}/rc.d/rcsysinit.d/S00mountvirtfs
-	ln -sf ../init.d/consolelog  ${EXTDIR}/rc.d/rcsysinit.d/S02consolelog
-	ln -sf ../init.d/modules     ${EXTDIR}/rc.d/rcsysinit.d/S05modules
-	ln -sf ../init.d/udev        ${EXTDIR}/rc.d/rcsysinit.d/S10udev
-	ln -sf ../init.d/swap        ${EXTDIR}/rc.d/rcsysinit.d/S20swap
-	ln -sf ../init.d/checkfs     ${EXTDIR}/rc.d/rcsysinit.d/S30checkfs
-	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rcsysinit.d/S40mountfs
-	ln -sf ../init.d/cleanfs     ${EXTDIR}/rc.d/rcsysinit.d/S45cleanfs
-	ln -sf ../init.d/udev_retry  ${EXTDIR}/rc.d/rcsysinit.d/S50udev_retry
-	ln -sf ../init.d/console     ${EXTDIR}/rc.d/rcsysinit.d/S70console
-	ln -sf ../init.d/localnet    ${EXTDIR}/rc.d/rcsysinit.d/S80localnet
-	ln -sf ../init.d/sysctl      ${EXTDIR}/rc.d/rcsysinit.d/S90sysctl
+	install -m ${MODE} lfs/sbin/ifup            /sbin
+	install -m ${MODE} lfs/sbin/ifdown          /sbin
+	install -m ${MODE} lfs/sbin/ifup.8          ${MAN8}
+	ln -sf ifup.8                               ${MAN8}/ifdown.8
+	install -m ${MODE} lfs/lib/services/ipv4-static-route  ${LIBDIR}
+	install -m ${MODE} lfs/lib/services/ipv4-static        ${LIBDIR}
+	install -m ${CONFMODE} lfs/lib/services/init-functions ${LIBDIR}
 	if [ ! -f ${EXTDIR}/sysconfig/createfiles ]; then \
      install -m ${CONFMODE} lfs/sysconfig/createfiles ${EXTDIR}/sysconfig/ ;\
@@ -89,46 +64,62 @@
      install -m ${CONFMODE} lfs/sysconfig/rc          ${EXTDIR}/sysconfig/ ;\
    fi
-	install -m ${MODE} lfs/sysconfig/network-devices/ifup   /sbin
-	install -m ${MODE} lfs/sysconfig/network-devices/ifdown /sbin
-	install -m ${MODE} lfs/sysconfig/network-devices/services/ipv4-static       ${LIBDIR}
-	install -m ${MODE} lfs/sysconfig/network-devices/services/ipv4-static-route ${LIBDIR}
+	if [ ! -f ${EXTDIR}/sysconfig/rc.site     ]; then \
+     install -m ${CONFMODE} lfs/sysconfig/rc.site     ${EXTDIR}/sysconfig/ ;\
+   fi
 
-install-consolelog: create-dirs
-	install -m ${MODE} contrib/init.d/consolelog   ${EXTDIR}/rc.d/init.d
-	ln -sf ../init.d/consolelog  ${EXTDIR}/rc.d/rcsysinit.d/S00consolelog
+links: files rcS rc0 rc1 rc2 rc3 rc4 rc5 rc6
 
-minimal: create-dirs 
-	install -m ${MODE} lfs/init.d/checkfs       ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/cleanfs       ${EXTDIR}/rc.d/init.d/
-	install -m ${CONFMODE} lfs/init.d/functions ${EXTDIR}/rc.d/init.d/
-	install -m ${CONFMODE} lfs/init.d/functions ${LIBDIR}
-	install -m ${MODE} lfs/init.d/halt          ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/localnet      ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/mountfs       ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/mountvirtfs   ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/rc            ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/reboot        ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/sendsignals   ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/setclock      ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/swap          ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/udev          ${EXTDIR}/rc.d/init.d/
+rcS:
+	ln -sf ../init.d/mountvirtfs ${EXTDIR}/rc.d/rcS.d/S00mountvirtfs
+	ln -sf ../init.d/consolelog  ${EXTDIR}/rc.d/rcS.d/S02consolelog
+	ln -sf ../init.d/modules     ${EXTDIR}/rc.d/rcS.d/S05modules
+	ln -sf ../init.d/localnet    ${EXTDIR}/rc.d/rcS.d/S08localnet
+	ln -sf ../init.d/udev        ${EXTDIR}/rc.d/rcS.d/S10udev
+	ln -sf ../init.d/swap        ${EXTDIR}/rc.d/rcS.d/S20swap
+	ln -sf ../init.d/checkfs     ${EXTDIR}/rc.d/rcS.d/S30checkfs
+	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rcS.d/S40mountfs
+	ln -sf ../init.d/cleanfs     ${EXTDIR}/rc.d/rcS.d/S45cleanfs
+	ln -sf ../init.d/udev_retry  ${EXTDIR}/rc.d/rcS.d/S50udev_retry
+	ln -sf ../init.d/console     ${EXTDIR}/rc.d/rcS.d/S70console
+	ln -sf ../init.d/sysctl      ${EXTDIR}/rc.d/rcS.d/S90sysctl
+
+rc0:
+	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc0.d/K80network
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc0.d/K90sysklogd
 	ln -sf ../init.d/sendsignals ${EXTDIR}/rc.d/rc0.d/S60sendsignals
 	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rc0.d/S70mountfs
 	ln -sf ../init.d/swap        ${EXTDIR}/rc.d/rc0.d/S80swap
+	ln -sf ../init.d/localnet    ${EXTDIR}/rc.d/rc0.d/S90localnet
 	ln -sf ../init.d/halt        ${EXTDIR}/rc.d/rc0.d/S99halt
+
+rc1:
+	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc1.d/K80network
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc1.d/K90sysklogd
+
+rc2:
+	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc2.d/K80network
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc2.d/K90sysklogd
+
+rc3:
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc3.d/S10sysklogd
+	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc3.d/S20network
+
+rc4:
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc4.d/S10sysklogd
+	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc4.d/S20network
+
+rc5:
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc5.d/S10sysklogd
+	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc5.d/S20network
+
+rc6:
+	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc6.d/K80network
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc6.d/K90sysklogd
 	ln -sf ../init.d/sendsignals ${EXTDIR}/rc.d/rc6.d/S60sendsignals
 	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rc6.d/S70mountfs
 	ln -sf ../init.d/swap        ${EXTDIR}/rc.d/rc6.d/S80swap
+	ln -sf ../init.d/localnet    ${EXTDIR}/rc.d/rc6.d/S90localnet
 	ln -sf ../init.d/reboot      ${EXTDIR}/rc.d/rc6.d/S99reboot
-	ln -sf ../init.d/mountvirtfs ${EXTDIR}/rc.d/rcsysinit.d/S00mountvirtfs
-	ln -sf ../init.d/udev        ${EXTDIR}/rc.d/rcsysinit.d/S10udev
-	ln -sf ../init.d/swap        ${EXTDIR}/rc.d/rcsysinit.d/S20swap
-	ln -sf ../init.d/checkfs     ${EXTDIR}/rc.d/rcsysinit.d/S30checkfs
-	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rcsysinit.d/S40mountfs
-	ln -sf ../init.d/cleanfs     ${EXTDIR}/rc.d/rcsysinit.d/S45cleanfs
-	if [ ! -f ${EXTDIR}/sysconfig/rc          ]; then \
-      install -m ${CONFMODE} lfs/sysconfig/rc ${EXTDIR}/sysconfig/; \
-   fi
 
-.PHONY: all create-dirs install 
+.PHONY: all create-dirs install files links rcS rc0 rc1 rc2 rc3 rc4 rc5 rc6
 
Index: bootscripts/README
===================================================================
--- bootscripts/README	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/README	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -1,48 +1,43 @@
 Network Configuration:
    Script Files:
-      /etc/rc.d/init.d/network
+      /etc/rc.d/init.d/*
       /sbin/ifup
       /sbin/ifdown
-      /lib/boot/*/*
+      /lib/lsb/*
 
    Configuration Files:
       /etc/sysconfig/ifconfig.*
-      Note: ifconfig.* could be either a file or directory,
-            but the filename extension must be the same name
-            as the network interface you wish it to belong to.
-            The files within the directory will be processed
-            in alphanumerical order on boot, and reversed on
-            shutdown.
-      - IFACE: the interface that is being configured (e.g. eth0)
-      - SERVICE: which script to run in services directory.
-      - ONBOOT: if set to yes, this interface will be started on
-                bootup, and stopped on shutdown
+      Note: ifconfig.* files will be processed
+            in alphanumerical order on boot, and reversed on shutdown.
+      - IFACE  : The interface that is being configured (e.g. eth0)
+      - SERVICE: Which script to run in services directory.
+      - ONBOOT : If set to yes, this interface will be started on bootup
 
       /etc/sysconfig/network
-      - HOSTNAME: Value of the system's hostname
+      - HOSTNAME: Value of the system's hostname  (From LFS Book)
+                  This value may also be set in /etc/sysconfig/rc.site
 
    Additional Configuration:
-      ipv4-static:
-      - IP: static IP Address
-      - GATEWAY: Specifies the IP Address of the gateway server
-      - PREFIX: CIDR prefix of IP Address, defaults to 24 if not set
-      - PEER: IP Address of peer (for point-to-point connections and tunnels)
-      - BROADCAST: broadcast address
+      SERVICE ipv4-static:
+      - IP       : Static IP Address
+      - GATEWAY  : Specifies the IP Address of the gateway server
+      - PREFIX   : CIDR prefix of IP Address, defaults to 24 if not set
+      - PEER     : IP Address of peer (for point-to-point connections and tunnels)
+      - BROADCAST: Broadcast address
 
-      ipv4-static-route:
-      - TYPE: network (default type if not specified), default, host or
-        unreachable
-      - IP: IP Address of target (for network, host and unreachable)
-      - PREFIX: CIDR prefix of target (for network, host and unreachable)
+      SERVICE ipv4-static-route:
+      - TYPE   : Network (default type if not specified), default, host or unreachable
+      - IP     : IP Address of target (for network, host and unreachable)
+      - PREFIX : CIDR prefix of target (for network, host and unreachable)
       - GATEWAY: IP Address of gateway to reach target (for network and default)
 
 
 SetClock configuration:
-   Script Files:
-      /etc/rc.d/init.d/setclock
+
+      /etc/rc.d/init.d/cleanfs
       - SKIPTMPCLEAN: skips cleaning of /tmp directory
 
    Configuration Files:
-      /etc/sysconfig/clock
+      /etc/sysconfig/clock or /etc/sysconfig/rc.site
       - UTC: 1 assumes hwclock is in UTC
              0 assumes hwclock is in local time
Index: bootscripts/lfs/init.d/checkfs
===================================================================
--- bootscripts/lfs/init.d/checkfs	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/checkfs	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -7,4 +7,5 @@
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
 #               A. Luebke - luebke@users.sourceforge.net
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -38,36 +39,38 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    start)
       if [ -f /fastboot ]; then
-         boot_mesg -n "/fastboot found, will not perform" ${INFO}
-         boot_mesg " file system checks as requested."
-         echo_ok
+         msg="/fastboot found, will omit "
+         msg="${msg} file system checks as requested.\n"
+         log_info_msg "${msg}"
          exit 0
       fi
 
-      boot_mesg "Mounting root file system in read-only mode..."
+      log_info_msg "Mounting root file system in read-only mode... "
       mount -n -o remount,ro / >/dev/null
-      evaluate_retval
 
       if [ ${?} != 0 ]; then
-         echo_failure
-         boot_mesg -n "FAILURE:\n\nCannot check root" ${FAILURE}
-         boot_mesg -n " filesystem because it could not be mounted"
-         boot_mesg -n " in read-only mode.\n\nAfter you"
-         boot_mesg -n " press Enter, this system will be"
-         boot_mesg -n " halted and powered off."
-         boot_mesg -n "\n\nPress enter to continue..." ${INFO}
-         boot_mesg "" ${NORMAL}
+         log_failure_msg2
+         msg="\n\nCannot check root "
+         msg="${msg}filesystem because it could not be mounted "
+         msg="${msg}in read-only mode.\n\n"
+         msg="${msg}After you press Enter, this system will be "
+         msg="${msg}halted and powered off.\n\n"
+         log_failure_msg "${msg}"
+
+         log_info_msg "Press Enter to continue..." 
          wait_for_user
          /etc/rc.d/init.d/halt stop
+      else
+         log_success_msg2
       fi
 
       if [ -f /forcefsck ]; then
-         boot_mesg -n "/forcefsck found, forcing file" ${INFO}
-         boot_mesg " system checks as requested."
-         echo_ok
+         msg="\n/forcefsck found, forcing file" 
+         msg="${msg} system checks as requested."
+         log_success_msg "$msg"
          options="-f"
       else
@@ -75,33 +78,31 @@
       fi
 
-      boot_mesg "Checking file systems..."
-      # Note: -a option used to be -p; but this fails e.g.
-      # on fsck.minix
+      log_info_msg "Checking file systems..."
+      # Note: -a option used to be -p; but this fails e.g. on fsck.minix
       fsck ${options} -a -A -C -T
       error_value=${?}
 
       if [ "${error_value}" = 0 ]; then
-         echo_ok
+         log_success_msg2
       fi
 
       if [ "${error_value}" = 1 ]; then
-         echo_warning
-         boot_mesg -n "WARNING:\n\nFile system errors" ${WARNING}
-         boot_mesg -n " were found and have been corrected. "
-         boot_mesg -n " You may want to double-check that"
-         boot_mesg -n " everything was fixed properly."
-         boot_mesg "" ${NORMAL}
+         msg="\nWARNING:\n\nFile system errors "
+         msg="${msg}were found and have been corrected.\n"
+         msg="${msg}You may want to double-check that "
+         msg="${msg}everything was fixed properly."
+         log_warning_msg "$msg"
       fi
 
       if [ "${error_value}" = 2 -o "${error_value}" = 3 ]; then
-         echo_warning
-         boot_mesg -n "WARNING:\n\nFile system errors" ${WARNING}
-         boot_mesg -n " were found and have been been"
-         boot_mesg -n " corrected, but the nature of the"
-         boot_mesg -n " errors require this system to be"
-         boot_mesg -n " rebooted.\n\nAfter you press enter,"
-         boot_mesg -n " this system will be rebooted"
-         boot_mesg -n "\n\nPress Enter to continue..." ${INFO}
-         boot_mesg "" ${NORMAL}
+         msg="\nWARNING:\n\nFile system errors "
+         msg="${msg}were found and have been been "
+         msg="${msg}corrected, but the nature of the "
+         msg="${msg}errors require this system to be rebooted.\n\n"
+         msg="${msg}After you press enter, "
+         msg="${msg}this system will be rebooted\n\n"
+         log_failure_msg "$msg"
+
+         log_info_msg "Press Enter to continue..." 
          wait_for_user
          reboot -f
@@ -109,28 +110,29 @@
 
       if [ "${error_value}" -gt 3 -a "${error_value}" -lt 16 ]; then
-         echo_failure
-         boot_mesg -n "FAILURE:\n\nFile system errors" ${FAILURE}
-         boot_mesg -n " were encountered that could not be"
-         boot_mesg -n " fixed automatically.  This system"
-         boot_mesg -n " cannot continue to boot and will"
-         boot_mesg -n " therefore be halted until those"
-         boot_mesg -n " errors are fixed manually by a"
-         boot_mesg -n " System Administrator.\n\nAfter you"
-         boot_mesg -n " press Enter, this system will be"
-         boot_mesg -n " halted and powered off."
-         boot_mesg -n "\n\nPress Enter to continue..." ${INFO}
-         boot_mesg "" ${NORMAL}
+         msg="\nFAILURE:\n\nFile system errors "
+         msg="${msg}were encountered that could not be "
+         msg="${msg}fixed automatically.  This system "
+         msg="${msg}cannot continue to boot and will "
+         msg="${msg}therefore be halted until those "
+         msg="${msg}errors are fixed manually by a "
+         msg="${msg}System Administrator.\n\n"
+         msg="${msg}After you press Enter, this system will be "
+         msg="${msg}halted and powered off.\n\n"
+         log_failure_msg "$msg"
+
+         log_info_msg "Press Enter to continue..." 
          wait_for_user
-        /etc/rc.d/init.d/halt stop
+         /etc/rc.d/init.d/halt stop
       fi
 
       if [ "${error_value}" -ge 16 ]; then
-         echo_failure
-         boot_mesg -n "FAILURE:\n\nUnexpected Failure" ${FAILURE}
-         boot_mesg -n " running fsck.  Exited with error"
-         boot_mesg -n " code: ${error_value}."
-         boot_mesg "" ${NORMAL}
+         msg="\nFAILURE:\n\nUnexpected Failure "
+         msg="${msg}running fsck.  Exited with error "
+         msg="${msg} code: ${error_value}."
+         log_failure_msg $msg
          exit ${error_value}
       fi
+
+      exit 0
       ;;
    *)
Index: bootscripts/lfs/init.d/cleanfs
===================================================================
--- bootscripts/lfs/init.d/cleanfs	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/cleanfs	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -27,65 +28,68 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 # Function to create files/directory on boot.
-create_files() {
-   # Read in the configuration file.
+function create_files() 
+{
+   # Input to file descriptor 9 and output to stdin (redirection)
    exec 9>&0 < /etc/sysconfig/createfiles
-      while read name type perm usr grp dtype maj min junk
-      do
-         # Ignore comments and blank lines.
-               case "${name}" in
-            ""|\#*) continue ;;
+
+   while read name type perm usr grp dtype maj min junk
+   do
+      # Ignore comments and blank lines.
+      case "${name}" in
+         ""|\#*) continue ;;
+      esac
+
+      # Ignore existing files.
+      if [ ! -e "${name}" ]; then
+         # Create stuff based on its type.
+         case "${type}" in
+            dir)
+               mkdir "${name}"
+               ;;
+            file)
+               :> "${name}"
+               ;;
+            dev)
+               case "${dtype}" in
+                  char)
+                     mknod "${name}" c ${maj} ${min}
+                     ;;
+                  block)
+                     mknod "${name}" b ${maj} ${min}
+                     ;;
+                  pipe)
+                     mknod "${name}" p
+                     ;;
+                  *) 
+                     log_warning_msg "\nUnknown device type: ${dtype}" 
+                     ;;
+               esac
+               ;;
+            *)
+               log_warning_msg "\nUnknown type: ${type}" 
+               continue
+               ;;
          esac
 
-         # Ignore existing files.
-         if [ ! -e "${name}" ]; then
-            # Create stuff based on its type.
-            case "${type}" in
-               dir)
-                  mkdir "${name}"
-                  ;;
-               file)
-                  :> "${name}"
-                  ;;
-               dev)
-                  case "${dtype}" in
-                     char)
-                        mknod "${name}" c ${maj} ${min}
-                        ;;
-                     block)
-                        mknod "${name}" b ${maj} ${min}
-                        ;;
-                     pipe)
-                        mknod "${name}" p
-                        ;;
-                     *) 
-                        boot_mesg -n "\nUnknown device type: ${dtype}" ${WARNING}
-                        boot_mesg "" ${NORMAL}
-                        ;;
-                  esac
-                  ;;
-               *)
-                  boot_mesg -n "\nUnknown type: ${type}" ${WARNING}
-                  boot_mesg "" ${NORMAL}
-                  continue
-                  ;;
-            esac
+         # Set up the permissions, too.
+         chown ${usr}:${grp} "${name}"
+         chmod ${perm} "${name}"
+      fi
+   done
 
-            # Set up the permissions, too.
-            chown ${usr}:${grp} "${name}"
-            chmod ${perm} "${name}"
-         fi
-      done
+   # Close file descriptor 9 (end redirection)
    exec 0>&9 9>&-
+   return 0
 }
 
 case "${1}" in
    start)
-      boot_mesg -n "Cleaning file systems:" ${INFO}
+      log_info_msg "Cleaning file systems:" 
 
       if [ "${SKIPTMPCLEAN}" = "" ]; then
-         boot_mesg -n " /tmp" ${NORMAL}
+         log_info_msg2 "\n /tmp" 
          cd /tmp &&
          find . -xdev -mindepth 1 ! -name lost+found -delete || failed=1
@@ -103,8 +107,10 @@
 
       if egrep -qv '^(#|$)' /etc/sysconfig/createfiles 2>/dev/null; then
-         boot_mesg "Creating files and directories..."
-         create_files
+         log_info_msg "Creating files and directories... "
+         create_files      # Always returns 0
          evaluate_retval
       fi
+
+      exit $failed
       ;;
    *)
Index: bootscripts/lfs/init.d/console
===================================================================
--- bootscripts/lfs/init.d/console	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/console	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -7,4 +7,5 @@
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
 #               Alexander E. Patrakov
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -12,6 +13,4 @@
 #
 ########################################################################
-
-. /lib/boot/functions
 
 ### BEGIN INIT INFO
@@ -29,14 +28,20 @@
 ### END INIT INFO
 
+. /lib/lsb/init-functions
+
 # Native English speakers probably don't have /etc/sysconfig/console at all
-if [ -r /etc/sysconfig/console ]; then
-   . /etc/sysconfig/console
-else
+[ -r /etc/sysconfig/console ] && . /etc/sysconfig/console
+
+function is_true() 
+{
+   [ "$1" = "1" ] || [ "$1" = "yes" ] || [ "$1" = "true" ]
+}
+
+# See if we need to do anything
+if [ -z "${KEYMAP}"         ] && [ -z "${KEYMAP_CORRECTIONS}" ] &&
+   [ -z "${FONT}"           ] && [ is_true "${UNICODE}"       ] &&
+   [ -z "${LEGACY_CHARSET}" ]; then 
    exit 0
 fi
-
-is_true() {
-   [ "$1" = "1" ] || [ "$1" = "yes" ] || [ "$1" = "true" ]
-}
 
 failed=0
@@ -44,20 +49,20 @@
 case "${1}" in
    start)
-      boot_mesg "Setting up Linux console..."
       # There should be no bogus failures below this line!
+      log_info_msg "Setting up Linux console..."
 
       # Figure out if a framebuffer console is used
-      [ -d /sys/class/graphics/fb0 ] && USE_FB=1 || USE_FB=0
+      [ -d /sys/class/graphics/fb0 ] && use_fb=1 || use_fb=0
 
       # Figure out the command to set the console into the
       # desired mode
       is_true "${UNICODE}" &&
-         MODE_COMMAND="${ECHO} -en '\033%G' && kbd_mode -u" ||
-         MODE_COMMAND="${ECHO} -en '\033%@\033(K' && kbd_mode -a"
+         MODE_COMMAND="echo -en '\033%G' && kbd_mode -u" ||
+         MODE_COMMAND="echo -en '\033%@\033(K' && kbd_mode -a"
 
       # On framebuffer consoles, font has to be set for each vt in
       # UTF-8 mode. This doesn't hurt in non-UTF-8 mode also.
 
-      ! is_true "${USE_FB}" || [ -z "${FONT}" ] ||
+      ! is_true "${use_fb}" || [ -z "${FONT}" ] ||
          MODE_COMMAND="${MODE_COMMAND} && setfont ${FONT}"
 
@@ -67,6 +72,4 @@
       # show up and the unicode map of the font will not be
       # used.
-      # FIXME: Fedora Core also initializes two spare consoles
-      # - do we want that?
 
       for TTY in `grep '^[^#].*respawn:/sbin/agetty' /etc/inittab |
@@ -78,10 +81,10 @@
 
       # Set the font (if not already set above) and the keymap
-      is_true "${USE_FB}" || [ -z "${FONT}" ] ||
-         setfont $FONT ||
-         failed=1
+      [ "${use_fb}" == "1" || [ -z "${FONT}" ] || setfont $FONT || failed=1
+
       [ -z "${KEYMAP}" ] ||
          loadkeys ${KEYMAP} >/dev/null 2>&1 ||
          failed=1
+      
       [ -z "${KEYMAP_CORRECTIONS}" ] ||
          loadkeys ${KEYMAP_CORRECTIONS} >/dev/null 2>&1 ||
@@ -90,17 +93,19 @@
       # Convert the keymap from $LEGACY_CHARSET to UTF-8
       [ -z "$LEGACY_CHARSET" ] ||
-         dumpkeys -c "$LEGACY_CHARSET" |
-         loadkeys -u >/dev/null 2>&1 ||
+         dumpkeys -c "$LEGACY_CHARSET" | loadkeys -u >/dev/null 2>&1 ||
          failed=1
 
       # If any of the commands above failed, the trap at the
       # top would set $failed to 1
-      ( exit $failed )
+      ( exit $failed ) 
       evaluate_retval
-      ;;
-   *)
-      echo $"Usage:" "${0} {start}"
-      exit 1
-      ;;
+
+      exit $failed
+      ;;              
+
+   *)                 
+      echo $"Usage:"  "${0} {start}"
+      exit 1          
+      ;;              
 esac
 
Index: bootscripts/lfs/init.d/consolelog
===================================================================
--- bootscripts/lfs/init.d/consolelog	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/consolelog	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,5 +6,6 @@
 #
 # Authors     : Dan Nicholson - dnicholson@linuxfromscratch.org
-# Authors     : Gerard Beekmans  - gerard@linuxfromscratch.org
+#               Gerard Beekmans  - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -28,10 +29,10 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
-# set the default loglevel
-LOGLEVEL=7
+# set the default loglevel if needed
+LOGLEVEL=${LOGLEVEL:-7}
 
-[ -r /etc/sysconfig/console ] &&  . /etc/sysconfig/console
+[ -r /etc/sysconfig/console ] && . /etc/sysconfig/console
 
 case "${1}" in
@@ -39,12 +40,15 @@
       case "$LOGLEVEL" in
       [1-8])
-         boot_mesg "Setting the console log level to ${LOGLEVEL}..."
+         log_info_msg "Setting the console log level to ${LOGLEVEL}..."
          dmesg -n $LOGLEVEL
          evaluate_retval
+         exit 0
          ;;
+
       *)
-         boot_mesg "Console log level '${LOGLEVEL}' is invalid" ${FAILURE}
-         echo_failure
+         log_failure_msg "Console log level '${LOGLEVEL}' is invalid"
+         exit 1
          ;;
+      
       esac
       ;;
@@ -55,11 +59,12 @@
          read level line < /proc/sys/kernel/printk
       else
-         boot_mesg "Can't read the current console log level" ${FAILURE}
-         echo_failure
+         log_failure_msg "Can't read the current console log level"
+         exit 1
       fi
 
       # Print the value
       if [ -n "$level" ]; then
-         ${ECHO} -e "${INFO}The current console log level is ${level}${NORMAL}"
+         log_info_msg "The current console log level is ${level}\n"
+         exit 0
       fi
       ;;
